=== debian/control ===
Source: rpi-imager
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Floris Bos <bos@je-eigen-domein.nl>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkg-config,
 libarchive-dev,
 zlib1g-dev,
 liblzma-dev,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 qtbase5-dev,
 qtbase5-dev-tools,
 qtdeclarative5-dev,
 libqt5svg5-dev,
 qttools5-dev,
 libgnutls28-dev,
 libdrm-dev,
 qml-module-qtquick2,
 qml-module-qtquick-controls2,
 qml-module-qtquick-layouts,
 qml-module-qtquick-templates2,
 qml-module-qtquick-window2,
 qml-module-qtgraphicaleffects,
Standards-Version: 4.6.2
Homepage: https://www.raspberrypi.org/

Package: rpi-imager
Architecture: amd64 armhf arm64 ppc64el riscv64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 qml-module-qtquick2,
 qml-module-qtquick-controls2,
 qml-module-qtquick-layouts,
 qml-module-qtquick-templates2,
 qml-module-qtquick-window2,
 qml-module-qtgraphicaleffects,
 dosfstools,
 fdisk,
Recommends:
 udisks2,
 libjs-bootstrap4,
 libjs-jquery,
Description: Raspberry Pi imaging utility
 Graphical utility user-interface to write (optionally compressed) disk images
 (from local files or remote hosts) to removable storage. Primarily intended
 for use with OS images for the Raspberry Pi.
