=== debian/watch ===
version=4
opts=\
  repacksuffix=+noembed,\
  dversionmangle=s/\+noembed$//,\
  filenamemangle=s/.+\/v?@ANY_VERSION@\.tar\.gz/@PACKAGE@_$1\.orig\.tar\.gz/ \
  https://github.com/raspberrypi/@PACKAGE@/tags .*/v?@ANY_VERSION@\.tar\.gz
