=== debian/changelog ===
rpi-imager (2.0.0) unstable; urgency=medium

  * UI: Complete redesign, now as a wizard
  * OS customisation: Add Raspberry Pi Connect step
  * App Options: Custom repository selection UI
  * OS customisation: Rebuilt back-end in C++
  * build: Custom Qt 6.9.3 builds for each platform

  -- Tom Dewey <tom.dewey@raspberrypi.com>  Fri, 10 Oct 2025 17:00:00 +0100

rpi-imager (1.9.7) unstable; urgency=medium

  * OS customisation:
    - Fixup SSH key duplication in written OS
    - Fixup 'Beep', 'Eject', 'Telemetry' option persistence
    - Improve ComboBox behaviours
  * Storage Device Selection: Begin observing at start of day,
      improve removal notifications.
  * windows: Autogenerate manifest version information from the build
  * windows, macos, linux: Add PlatformQuirks module to deal with host
      hardware quirks. Today, just used on Windows for nVidia lockups.
  * all: Add OS list refresh jitter and override
  * all: Generate timezone data from tzdata
  * OS customisation: Refactor dialogs, data reset
  * Cache Management: Fixup destruction segfault
  * Embedded: Unified build
  * macOS: Build custom Qt 6.9.1

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Thu, 31 Jul 2025 17:00:00 +0100

rpi-imager (1.9.6) unstable; urgency=medium

  * OS customisation:
    - Add Wi-Fi country selection validator
    - Add new SSH key error messages
  * i18n: Updated Chinese, French, Italian, Russian translations
  * windows: Use normal mode for file writing operations
  * all: Refactor drive formatting logic, home-grown formatter

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Mon, 21 Jul 2025 17:00:00 +0100

rpi-imager (1.9.5) unstable; urgency=medium

  * OS customisation:
    - Enhanced validation of SSH keys
    - Improved keyboard navigation
  * OS list:
    - Add architecture sorting support
  * UI:
    - Better keyboard navigation support throughout
  * bug:
    - Fix ISO9660 handling
    - Fix spurious writing Updates
  * build:
    - Automatic discovery of translation files
  * deps:
    - Update to libarchive 3.8.1
    - Update to nghttp2 1.66.0
  * i18n:
    - Add Irish language, Bengali language
    - Fixup broken binding when swapping between languages
    - Updated French, German translation
  * macOS:
    - Add support for writing to virtual drives
    - Styled DMGs
  * packaging:
    - Removed unused Qt Quick Controls
  * windows:
    - Restore delayed wlanpi loading
  
 -- Tom Dewey <tom.dewey@raspberrypi.com>  Fri, 11 Jul 2025 17:00:00 +0100

rpi-imager (1.9.4) unstable; urgency=medium

  * Windows: Switch to Inno Setup for installer
  * Windows: Add signing for binaries, installer, and uninstaller
  * Windows: Add administrator privileges and NSIS removal support
  * macOS: Fix .app naming in .dmg packages
  * macOS: Improve build reliability and programmatic copyright handling
  * Linux: Hide system drives in destination popup
  * all: Fix OptionsPopup not handling 'Esc' key
  * all: Internal refactoring and QML code improvements
  * all: Add support for more archive formats via libarchive
  * all: Performance improvements in download/extract operations
  * qml: Split main UI into multiple component files
  * qml: Add Style singleton and ImCloseButton component
  * qml: Make options popup modal and improve accessibility
  * qml: Fix various QML linting warnings and unqualified accesses
  * i18n: Updated Italian translation
  * i18n: Added Georgian translation
  * i18n: Make 'Recommended' OS string translatable
  * packaging: Add custom AppImage build script with Qt detection
  * packaging: Add custom Qt build script with unprivileged mode
  * packaging: Include custom Qt 6.9.0
  * packaging: Migrate dependencies to FetchContent system
  * dependencies: Update to libarchive 3.8.0
  * dependencies: Update to cURL 8.13.0
  * dependencies: Update to nghttp2 1.65.0
  * dependencies: Update to zstd 1.5.7
  * dependencies: Update to xz/liblzma 5.8.1
  * dependencies: Update to zlib 1.4.1.1
  * cmake: Version requirement bumped to 3.22
  * cmake: Various build system improvements and hardening
  * build: Updated README with new build instructions
  * OS customisation: Remove 'Show password' checkbox

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Fri, 30 May 2025 17:00:00 +0100

rpi-imager (1.9.3) unstable; urgency=medium

  * Windows: Add quiet uninstaller flag
  * Windows: Fixup long filename construction in FAT partitions
  * i18n: Updated Portuguese translation
  * i18n: Updated zh-TW, zh-CN translations
  * i18n: Updated Korean translation
  * i18n: Make 'gigabytes' translatable
  * Storage Selection: Allow controllable filtering of system drives
  * Linux: Disable Wayland back-end
  * OS customisation: SSH key handling, regex verification
  * OS customisation: UI cleanup
  * deps: cURL 8.11.0, libarchive 3.7.7

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Fri, 07 Mar 2025 14:45:00 +0000

rpi-imager (1.9.2) unstable; urgency=medium

  * Drive List: Expose only physical devices - not volumes
  * i18n: German, Taiwanese, Catalan, Spanish, Slovak
    translations updated
  * i18n: Added Hebrew translation
  * qml: OS Customisation: Allow mouse selection in
    comboboxes
  * qml: MessagePopup: Constrain text, align to the center
  * packaging: debian: Ignore AppImages and ci scripts

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 02 Oct 2024 18:57:00 +0000

rpi-imager (1.9.0) unstable; urgency=medium

  * ui: Upgrade to Qt6.7, bringing new controls to everything
  * packaging: Migrate to AppImage-first distribution
  * packaging: Sign with new Raspberry Pi Ltd key
  * host deps: Ubuntu 22.04+, macOS 11+, Windows 10+
  * Popups: Removed click-outside closing behaviour
  * Selection Windows: Fixed layouts to fill the windows
  * build: Dependencies have been vendored for consistency
  * build: Require non-package-manager version of Qt
  * security: Use platform crypto, SSL libraries where possible

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 4 Sep 2024 18:57:00 +0000


