=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# Get the list of packages that should be built based on build profiles
PACKAGES := $(shell dh_listpackages)

%:
	dh $@

.PHONY: override_dh_strip 
override_dh_strip: 
	dh_strip --exclude=AppImage --exclude=rpi-imager
